VERSION 5.00
Begin VB.Form functions 
   Caption         =   "Form1"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "functions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim row, col As Integer
Dim r, c As Integer
Dim k As Integer


'// All matrices passed are ByRef by default
Sub transpose(ByRef matrix() As Double)
    Dim upper, lower As Integer
    Dim temp() As Double
    
        
    upper = UBound(matrix)
    lower = LBound(matrix)
    
    ReDim temp(lower To upper, lower To upper)
    
    For row = lower To upper
        For col = lower To upper
            temp(row, col) = matrix(row, col)
        Next
    Next
    
    For row = lower To upper
        For col = lower To upper
            matrix(row, col) = temp(col, row)
        Next
    Next
    
End Sub

'// All matrices passed are ByRef by default
Sub add(matrixA() As Double, matrixB() As Double, result() As Double)
    
    Dim rowsA, colsA, rowsB, colsB As Integer
    
    rowsA = UBound(matrixA, 1)
    colsA = UBound(matrixA, 2)
    rowsB = UBound(matrixB, 1)
    colsB = UBound(matrixB, 2)
    
    ReDim result(1 To rowsA, 1 To colsA)
    
    
    For row = 1 To rowsA
        For col = 1 To colsA
            result(row, col) = matrixA(row, col) + matrixB(row, col)
        Next
    Next
End Sub

'// All matrices passed are ByRef by default
Sub multiply(matrixA() As Double, matrixB() As Double, result() As Double)
    Dim rowsA, colsA, rowsB, colsB As Integer
    
        
    rowsA = UBound(matrixA, 1)
    colsA = UBound(matrixA, 2)
    colsB = UBound(matrixB, 2)
    
    ReDim result(1 To rowsA, 1 To colsB)
    
    
    For row = 1 To rowsA
        For col = 1 To colsB
            For k = 1 To colsA
                result(row, col) = result(row, col) + matrixA(row, k) * matrixB(k, col)
            Next
        Next
    Next
End Sub

Sub Pause(seconds As Integer)
    Const SECS_INDAY = 24! * 60 * 60 '// Seconds per day
    Dim start As Single
    start = Timer
    Do: Loop Until (Timer + SECS_INDAY - start) Mod SECS_INDAY >= seconds
End Sub


Sub TermCommand(ByVal InCommand As String)
    'Sends response to escape seq command
    '
    'There are many Esc Sequences that terminal need to understand
    'but only the essentials ones are covered here
    Dim OutCommand As String
    
    Select Case InCommand
    Case "[c" 'Server: What device are you?
    OutCommand = "[?1;2c" 'Terminal: I am a VT100 machine
    Case "[6n" 'Server: Gimme some cursor information
    OutCommand = "[25;80R" 'Terminal: Here's my cursor position
    Case Else 'Server: Unkown request
    Exit Sub 'Terminal: No reply
    End Select
    slam.Winsock1.SendData Chr(27) + OutCommand
End Sub
Sub CloseConnection()
    'Close Socket connection
    slam.Winsock1.Close
    AddLog "Connection to host lost" & vbCrLf
    MsgBox "Connection to host lost", vbInformation
    EnableConnect
    slam.moveDoneTimer.Enabled = False
End Sub
Sub AddLog(LogEntry As String)
    'Add text to log
    With slam.Text2
    .Text = .Text + LogEntry
    .SelStart = Len(.Text)
    End With
    Me.Refresh
End Sub
Sub EnableConnect()
    'Enable user to connect
    slam.connect.Enabled = True
    slam.disconnect.Enabled = False
    slam.ipAddress.Enabled = True
    slam.Port.Enabled = True
    slam.VScroll1.Enabled = False
End Sub
Sub DisableConnect()
    'Disable user from connecting
    slam.connect.Enabled = False
    slam.disconnect.Enabled = True
    slam.ipAddress.Enabled = False
    slam.Port.Enabled = False
End Sub

Function FindEscapeSeq(ByVal TextInput As String) As String
    'Look for escape sequences
    
    Dim Pos As Integer
    Dim SeqLength As Integer
    Dim SeqText As String
    
    Pos = 0
    'Search for commands
    Do
    Pos = Pos + 1
    'Look for escape char
    If Mid(TextInput, Pos, 1) = Chr(27) Then
    'Reset
    SeqText = Empty
    Do
    Pos = Pos + 1
    SeqText = SeqText + Mid(TextInput, Pos, 1)
    
    If Mid(TextInput, Pos + 1, 1) = Chr(27) Then
    TermCommand SeqText 'Execute Command
    FindEscapeSeq = FindEscapeSeq + FindEscapeSeq(Right(TextInput, Len(TextInput) - (Pos)))
    Exit Function
    ElseIf Mid(TextInput, Pos + 1, 1) = Chr(13) Then
    TermCommand SeqText 'Execute command
    Exit Do
    End If
    
    If Pos = Len(TextInput) Then
    TermCommand SeqText
    Exit Do
    End If
    Loop
    Else
    FindEscapeSeq = FindEscapeSeq + Mid(TextInput, Pos, 1)
    End If
    
    If Pos = Len(TextInput) Then Exit Do
    
    Loop
    
End Function
